CHANGELOG for 2.x
=================
## 2.2.0 (2017-05-07)
* [New] Dropped the support for PHP 5.5. The minimum version is 5.6.
* [Fixed] The `Spress-installer` plugin is included in the `composer.json` file when a new blank theme is created.
* [Fixed] Fixed an issue when loading layouts and includes of the current theme.
* [Fixed] Fixed an issue related with the presedence between the theme's assets and the site's assets.
* [Fixed] Bug #107 fixed: ".htaccess not being included in build".
* [Fixed] Fixed an issue related to the convertion to array of a `Finder` class in `FilesystemDataSource` class.
* [Improved] Updated `PluginManagerBuilder` class with support for loading several plugins
from extra->spress_class attribute of a plugin's `composer.json` file.
* [Improved] Renamed some tests with a more descritive name.
* [Improved] Fixed some descriptions in commands.
* [Improved] Replaced the use of PHPUnit_Framework_TestCase class by TestCase.
* [Improved] Deleted the `.htaccess` value from `include` key of configuration files due to the fix #107.

## 2.2.0-rc (2017-01-15)
* [New] Support for themes. See the new feature #98.
* [New] Package manager with the following new commands: `new:theme`, `add:plugin`, `remove:plugin` and `update:plugin`. Additionaly, `new:site` command has been updated for scaffolding new sites using themes. See the new feature #96.
* [New] Allow default attributes on "pages" collection. See new feature #93.
* [New] New options for applying `avoid_renderizer` feature to type of files and files belong to a path (relative to `src/content` folder). See new feature #91.
* [New] Added a verbosity level param (optional) to  the `write` method of IOInterface.
* [New] Added verbosity and very-verbosity level messages to the `ContentManager` class.
* [New] Added support for overwriting messages to the output in IOInterface.
* [New] Added support for ask choice questions in IOInterface.
* [New] Added the method `getSpress` to `CommandEnvironmentInterface`.
* [New] Updated to using Symfony 3.2 components.
* [Improved] The terms generated by TaxonomyGenerator for each item appears sorted.
* [Fixed] Avoid an error using `--force` option of `new:site` command over a
non-empty directory that contains "hidden" directories and files.
* [Fixed] Fixed a bug related with the "pagination generator" and the draft posts. See bug #101.
* [Fixed] Fixed the `askAndHideAnswer` method of `ConsoleIO` class to use the fallback argument.

## 2.1.3 (2016-07-03)
* [New] Class `FileInfo` has been added to the support classes set of the core.
* [New] New configuration value aimed to plugin manager builder for excluding directories in the disconvering class phase. Useful to avoid scaning test classes.
* [Fixed] Fixed the truncated `title_path` attribute when the filename contains dots before the extension. More details in bug #88.
* [Fixed] The value of `title_path` is not altered when it is parsed by `FilesystemDataSource` class. More details in bug #88.
* [Fixed] If you set `preserve_path_title` attribute to `true` you will get the title parsed from the filename as-is (without the date part). Only `rawurlencode` function is applied. See PR #90.

## 2.1.2 (2016-05-23)
* [New] Two new methods have been added to StringWrapper class: `lower` and `upper`.
* [Fixed] Bug #80 has been fixed: "Composer install fails if no namespace is specified in new plugin". See PR #81.
* [Fixed] Bug #82 has been fixed: "Substr "---" in yaml string cause builder crash".
* [Fixed] Bug #83 has been fixed: "Same tags on different languages cause builder crash".

## 2.1.1 (2016-04-12)
* [Fixed] Bug #78 has been fixed: "/:basename permalink variable contains .html when using .html.twig".
* [Fixed] Bug #79 has been fixed: "Error loading plugin's dependencies with -s option at site:build command".
* [Improved] Clarified the message when `site:build` command is invoked against a non Spress site folder.

## 2.1.0 (2016-03-26)
* [New] Support for calling to an existing command inside a command plugin. The `CommandEnvironmentInterface` interface has been added and `CommandPluginInterface` has been updated with `setCommandEnvironment` and `getCommandEnvironment` methods. See feature #77.
* [New] Sort items of a collection. See feature #67.
* [New] Support to extends TwigRenderizer with tags. See PR #65.
* [New] Each item of a sorted collection has `next` and `prior` relationships. At compile time, you have access to these through `page.relationships.next` and `page.relationships.prior` variables. See feature #69.
* [New] Relationship collection for items. A new class has been added: `RelationshipCollection`. A new method getRelationshipCollection has been added to `ItemIterface`.
* [New] `MirrorConverter` class has been replaced by `MapConverter`. See feature #73. Fixed ticket: #28 "Support .twig extention".
* [New] Added `ItemCollection` class to Core support classes.
* [New] Added `getCollections` method in `CollectionManager` class.
* [New] Added `clearConverter` and `countConverter` methods in `ConverterManager` class.
* [Improved] Improved permalinks customizations. See PR #64.
* [Improved] Eliminated unnecessary calls to `setItem` method of `SiteAttribute` class in `ContentManager` class.
* [Improved] The methods for managing the collection of plugins in `PluginManager` class have been moved to a `Collection` class.
* [Improved] The methods for managing the collection of collection-item in `CollectionManager` class have been moved to a `Collection` class.
* [Improved] Clarified the error message in case of denied permissions when renaming the temporal file in `SelfUpdateCommand` class.
* [Fixed] Fixed the path available at `page.path` variable. Prior to this version, this variable contains the relative path to `src/content/` but with the filename extension changed by the Converter. Now, the original filename extension isn't altered. A new path snapshot has been created in `ItemIterface`.

## 2.0.2 (2016-01-16)
* [New] `PluginTester` class has been added to the core for testing plugins easily.
* [Fixed] Fixed an issue with the content retrieved by "after_render_page" event.
* [Fixed] A constant name of `ItemInterface` has been changed: `SNAPSHOT_AFTER_PAGE` -> `SNAPSHOT_AFTER_RENDER_PAGE`.

## 2.0.1 (2016-01-09)
* [Improved] Normalized the directory separator to '/' irrespective of the operating system.
* [Fixed] Fixed the file's extension `twig.html` in configuration files.
* [Fixed] Fixed the exception "A previous item exists with the same id" thrown by Taxonomy generator due to a key sensitive issue. A normalize method has been added. e.g: "news", "NEWS", " News " are the same term: "news".
* [Fixed] Fixed the namespace of `AttributeValueException` at `PaginationGenerator` class.

## 2.0.0 (2016-01-02)
* [New] `ConsoleIO` class uses Symfony CLI styles.
* [Improved] 100% tests passed in HHVM.
* [Fixed] Renamed the package name `yosymfony/spress-installer` to `spress/spress-installer`.
* [Fixed] Fixed a race condition with the `url` attribute of items before dispatch `spress.before_render_blocks` event.
* [Fixed] Questions made by commands are using `ConsoleIO` methods.
* [Fixed] Fixed a bug with the built-in server by which a relative URL that contains a dot inside the trailing component throws a 404 not found error. e.g: `/doc/2.0`.
* [Fixed] Added a default value for `$fallback` argument of `askHiddenResponseAndValidate` and `askAndHideAnswer` methods in `IOInterface`.

## 2.0.0-rc (2015-12-07)
* [New] Added MemoryDataSource, a datasource for generating dynamic content.
* [New] Support to sort items at `PaginationGenerator` with attributes `sort_by` and `sort_type. See #61.
* [New] Added `getGeneratorManager` method to `EnvironmentEvent` for managing generators at plugins.
* [Improved] Improved the way of generating the classname in PluginGenerator.
* [Improved] Minor changes over output styles.
* [Improved] Improved HttpServer with support to load internal resources (used with error page). Added a new hook: `handleOnAfterRequestFunction`. Bootstrap file has been included for using with internal pages like error page.
* [Improved] Minor improvements over the Spress application output.
* [Fixed] Now, `slug` method transform dot characters into dash characters.
* [Fixed] Fixed lifecycle: render phase starts after converter phase has been finished for all items.
* [Fixed] Changed the method `remove` by `removeCollection` in CollectionManager class.
* [Fixed] `PermalinkGenerator` adds an initial slash if the permalink doesn't start with it.
* [Fixed] `MissingAttributeException` and `AttributeValueException` has been moved to `Core\ContentManager\Exception.
* [Fixed] `ConsoleIO` passed to `spress.io` key (DI container) when `SiteBuildCommand` builds `Spress instance.
* [Fixed] Updated `spress-installer` version to ~2.0 at `composer.json.twig`.
* [Fixed] Fixed the message of the exception threw when a previous item exists.
* [Deleted] `ConfigValueException` has been deleted.

## 2.0.0-beta (2015-10-15)
* [New] Added a new converter for Markdown: ParsedownConverter. This converter is based on Parsedown by Emanuil Rusev. See http://parsedown.org/. Deals with issue #40.
* [New] Added command plugins: a new kind of plugins witch provides subcommand for `spress` executable. See #56.
* [New] Added `self-update` command with an alias `selfupdate` for keeping Spress up to date. See #60.
* [New] Taxonomy generator for grouping content around a set of terms. See #57.
* [New] Modified RenderizerInterface for throwing a `Yosymfony\Spress\Core\ContentManager\Renderizer\Exception\RenderException` if an error occurred during redering the content. Method affected: `renderBlocks` and `renderPage`.
* [New] Added a new special attributte `avoid_renderizer` for avoiding the renderizer phase over an item.
* [Improved] Additional autoload only be processed if exists a `composer.json` file in the root of the site folder.
* [Fixed] The separator for tags and categories of `new:post` command has been changed from space to comma. See issue #51.
* [Fixed] New template for spress plugin scaffold (`new:plugin` command) - fixed for 2.0 release. See issue #55.
* [Fixed] The `setUp` method of `FilesystemDataWriter removes the whole content of the output dir but VCS files. This means that `site:build` command doesn't remove the VCS files.
* [Deleted] Deleted the `site:new` alias for command `new:site`.

## 2.0.0-alpha (2015-08-12)
* [New] Data-sources: (issue #46) data sources can load site data from certain locations like filesystem or database.
* [New] Site structure (issue #41).
* [New] Data-writer (issue #44): The DataWriter's responsibility is to persist the content of the items.
* [New] Collections (issue #43): collections allow you to define a new type of document like page or post.
* [New] Generators (issue #45): Generators are used for generating new items of content.
* [New] These events `spress.before_convert`, `spress.after_convert` receive a ContentEvent as an argument.
* [New] Renderizer (issue #48): Renderizer are responsible for formatting content.
* [New] List of new events: `spress.before_render_blocks`, `spress.after_render_blocks`, `spress.before_render_page`, `spress.after_render_page`. See #49.
* [New] Established PHP 5.5 as minimum version (see #42).
* [New] List of new configuration attributes: `text_extensions`, `attribute_syntax`, `preserve_path_title`, `collections`, `data_sources`.
* [Improved] Updated Symfony componentes to 2.7.
* [Improved] Updated Markdown parser (michelf/php-markdown) from Michel Fortin.
* [Improved] Updated built-in theme Spresso to 2.0.
* [Deleted] Methods `initialize` and `getSupportExtension` of ConverterInterface have been deleted.
* [Deleted] TemplateManager class of plugin API.
* [Deleted] EnviromentEvent class.
* [Deleted] List of deleted events: `spress.after_convert_posts`, `spress.before_render_pagination`, `spress.after_render_pagination `, `spress.before_render`, `spress.after_render`. See #49.
* [Deleted] List of configuration attributes (config.yml) deleted because they have been marked as deprecated: `baseurl`, `paginate`, `paginate_path`, `limit_posts`, `processable_ext`, `destination`, `posts`, `includes`, `layouts`, `plugins`.
